VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsDirectory"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

Option Explicit
'
Private sFehler As String
Private fso As FileSystemObject

' declares used for choosing the folder
'==============================================
Const vbErr_PathNotFound = 76
Const INVALID_VALUE = -1

'==============================================

' declares to search folders
'===========================================
Private Declare Sub FindClose Lib "kernel32" (ByVal hFindFile As Long)
Private Declare Function FindFirstFileA Lib "kernel32" ( _
    ByVal lpFileName As String, _
    lpFindFileData As WIN32_FIND_DATA _
  ) As Long
Private Declare Function FindNextFileA Lib "kernel32" ( _
    ByVal hFindFile As Long, _
    lpFindFileData As WIN32_FIND_DATA _
  ) As Long
Private Declare Function GetFileAttributesA Lib "kernel32" (ByVal lpFileName As String) As Long

Private Type FILETIME
  dwLowDateTime As Long
  dwHighDateTime As Long
End Type

Private Type WIN32_FIND_DATA
  dwFileAttributes As Long
  ftCreationTime As FILETIME
  ftLastAccessTime As FILETIME
  ftLastWriteTime As FILETIME
  nFileSizeHigh As Long
  nFileSizeLow As Long
  dwReserved0 As Long
  dwReserved1 As Long
  cFileName As String * 260
  cAlternate As String * 14
End Type
' -----------------
' search for folders or files
' Path =  the path to the folder to be examined
' Pattern = used with files to collect only certain types
' Attribute = should be normal
' Recursive = used with folders True = process subfolders, False otherwise
' FolderOnly = collect folder names only
' -----------------
Friend Function FindFiles(ByVal Path As String, _
                            ByRef Files As Collection, _
                            Optional ByVal Pattern As String = "*.*", _
                            Optional ByVal Attributes As VbFileAttribute = vbNormal, _
                            Optional ByVal Recursive As Boolean = False) As Boolean
'
Const vbErr_PathNotFound = 76
Const INVALID_VALUE = -1
Dim FileAttr As Long
Dim FileName As String
Dim PathName As String
Dim hFind As Long
Dim WFD As WIN32_FIND_DATA
'
    On Error GoTo err_handler:
    FindFiles = False
    '
    'Initialisierung:
    If Right$(Path, 1) <> "\" Then _
        Path = Path & "\"
    If Files Is Nothing Then _
        Set Files = New Collection
    Pattern = LCase$(Pattern)
    
    ' start search
    hFind = FindFirstFileA(Path & "*", WFD)
    If hFind = INVALID_VALUE Then
        Exit Function
    End If
  
    ' continue search
    Do
        FileName = LeftB$(WFD.cFileName, InStrB(WFD.cFileName, vbNullChar))
        PathName = Path & FileName
        FileAttr = GetFileAttributesA(PathName)
        If Not (FileAttr And vbDirectory) Then
            ' the file type we want?
            If (FileAttr And Attributes) = Attributes Then
                If LCase$(FileName) Like Pattern Then
                    On Error Resume Next
                    Call Files.Add(PathName, Key:=CStr(PathName))
                    Err.Clear                        ' ignore duplicates
                    On Error GoTo err_handler:
                End If
            End If
        Else
            If FileAttr <> INVALID_VALUE And (FileName <> "." And FileName <> ".." And Recursive) Then
                Call FindFiles(PathName, Files, Pattern, Attributes, Recursive)
            End If
        End If
continue:
    Loop While FindNextFileA(hFind, WFD)
    
    FindClose hFind
    FindFiles = True
    Exit Function
    '
err_handler:
    Err.Clear
    Resume continue
'
End Function
' -----------------
' search for folders or files
' Path =  the path to the folder to be examined
' Pattern = used with files to collect only certain types
' Attribute = should be normal
' Recursive = used with folders True = process subfolders, False otherwise
' FolderOnly = collect folder names only
' -----------------
Friend Function findFolders(ByVal Path As String, _
                            ByRef pFolders As Collection, _
                            Optional ByRef Pattern As String = "*.*", _
                            Optional ByRef Attributes As VbFileAttribute = vbNormal, _
                            Optional ByRef SkipDups As Boolean = True) As Boolean
'
Dim FileAttr As Long
Dim FoldName As String
Dim PathName As String
Dim hFind As Long
Dim WFD As WIN32_FIND_DATA
'
    On Error GoTo err_handler:
    findFolders = False
    '
    'Initialisierung:
    If Right$(Path, 1) <> "\" Then _
        Path = Path & "\"
    If pFolders Is Nothing Then _
        Set pFolders = New Collection
    Pattern = LCase$(Pattern)
    
    ' start search
    hFind = FindFirstFileA(Path & "*", WFD)
    If hFind = INVALID_VALUE Then
        Exit Function
    End If
  
    ' continue search
    Do
        FoldName = LeftB$(WFD.cFileName, InStrB(WFD.cFileName, vbNullChar))
        PathName = Path & FoldName
        FileAttr = GetFileAttributesA(PathName)
        If FileAttr And vbDirectory Then
            If (FoldName <> "." And FoldName <> "..") Then
                If SkipDups Then
                    On Error Resume Next
                    Call pFolders.Add(Path & FoldName, Key:=CStr(PathName))
                    Err.Clear            ' ignore duplicates
                    On Error GoTo err_handler:
                Else
                    Call pFolders.Add(PathName)
                End If
            End If
            '
            If FileAttr <> INVALID_VALUE And (FoldName <> "." And FoldName <> "..") Then
                Call findFolders(PathName, pFolders, Pattern, Attributes, SkipDups)
            End If
        End If
continue:
    Loop While FindNextFileA(hFind, WFD)
    
    FindClose hFind
    findFolders = True
    Exit Function
    '
err_handler:
    Err.Clear
    Resume continue
'
End Function
'
Public Property Get getError() As String
'
    getError = sFehler
'
End Property
'
' pre processing
Private Sub Class_Initialize()
'
    sFehler = vbNullString
    Set fso = New FileSystemObject
    '
End Sub
'
' post processing
Private Sub Class_Terminate()
'
    Set fso = Nothing
'
End Sub

