VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsNlsConv"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'PMTabelle V2.1.8 - Copyright (C)2004 Klaus Dahlenburg, INCOMM GmbH
' complete rework of coding affecting all modules. Published under the terms
' and conditions of GNU General Public License Version 2, 1991 or later
'
' ===============
' changes:
'   dah-7 20/1/2004 - the property let changed to a sub to pass on the current
'                     version as well
'
' ===============
'
Option Explicit
'
Private lElement As Long
Private sNlsDef As String        ' default properties
Private sNlsNls As String        ' specific Nls properties
Private fsDatei As clsFileString
Private clsIni As clsPPStrings
Private sFehler As String
Private lRcNls As Long
Private sRetStr As String
Private sUseNlsDsn As String
Private tmp As Variant
Private sSubData() As String

'
Public Function getString(sKey As String, _
                lRc As Long, _
                vSubData As Variant, _
                Optional sApplicat As String = "Inserts") As String
    '
    lRc = 0
    '
    lRcNls = clsIni.getPPString(sDateiName:=sUseNlsDsn, _
                sVariable:=sKey, _
                sReturn:=sRetStr, _
                sApplication:=sApplicat)
    '
    If lRcNls <> 0 Then
        lRc = lRcNls
        getString = "? " & sKey & " ?  "
        Exit Function
    End If
    '
    ' if the request was for something other
    ' than "Strings" we pass it verbatim to the caller
    ' The same will be done for an empty string
    If sApplicat <> "Inserts" Then
        lRc = lRcNls
        getString = sRetStr
        Exit Function
    End If
    '
    ' check if any inserts have to made
    If Not IsArray(vSubData) Then
        ReDim sSubData(0)            ' single value passed so put it
        sSubData(0) = CStr(vSubData) ' into an array to have the same processing
    Else
        sSubData = vSubData             ' put array into our array
    End If
    '
    ' scan on recognized char
    ' \t    = convert to tab
    ' \n    = convert to line break
    ' \s    = convert to 1 space
    ' \(n)  = insert a text string. The number is used as index
    '
    Dim strLen As Long
    Dim sChar As String
    Dim i As Long
    '
    '
    tmp = Split(sRetStr, "\", -1, vbBinaryCompare)
    If UBound(tmp) < 1 Then
        getString = sRetStr
        Exit Function
    End If
    '
    getString = vbNullString
    For i = 0 To UBound(tmp)
        '
        ' if a line starts with a \ or ends in a \ the substring will
        ' be empty.
        ' We must take care of this because the user may want a \ at either
        ' the end or the beginning and therefore coded 2 \\ in a row
        ' Another pitfall is that a can line start with one of the
        ' characters we recognize and thus get erroneously processed as such.
        ' To distinguish we check on index (i) be zero and non-empty and
        ' skip the interpretation run
        '
        If tmp(i) = vbNullString And (i > 0 And i < UBound(tmp)) Then
            getString = getString & "\"
        '
        ' not the case so look for a command. But when the last char of the
        ' already processed string ends in a \ we skip checking because
        ' the user wants to have it not interpreted by coding n-times \ in
        ' front of it which we've honoured
        ElseIf (i > 0 And Right$(getString, 1) <> "\") Then
                If StrComp(Left$(tmp(i), 1), "n", vbBinaryCompare) = 0 Then
                    getString = getString & vbNewLine & Mid(tmp(i), 2)
                Else
                    If StrComp(Left$(tmp(i), 1), "s", vbBinaryCompare) = 0 Then
                        getString = getString & " " & Mid(tmp(i), 2)
                    Else
                        If StrComp(Left$(tmp(i), 1), "t", vbBinaryCompare) = 0 Then
                            getString = getString & vbTab & Mid(tmp(i), 2)
                        Else
                            If StrComp(Left$(tmp(i), 1), "(", vbBinaryCompare) = 0 Then
                                getString = getString + getInsert(Mid(tmp(i), 2), sSubData())
                            Else
                                getString = getString & tmp(i)
                            End If
                        End If
                    End If
                End If
            Else
                getString = getString & tmp(i)
        End If
               
    Next i
    '
End Function
                
Public Property Get getErr() As String
    getErr = sFehler
End Property
                
Public Sub setLang(sLang As String)
    sNlsNls = sUsePropPath & "\NLS\" & sLang & ".txt"
    If (fsDatei.existiertDatei(sNlsNls)) Then
        sUseNlsDsn = sNlsNls
    End If
End Sub
'
'  validate the index and return the completed string
'
Private Function getInsert(sData As String, vSubs() As String) As String
'
Dim vTmp As Variant
'
    '
    '   an empty String stems from \( at end of string
    If sData = vbNullString Then
        getInsert = getInsert & "(" & Mid(sData, 1)
        Exit Function
    End If
    '
    ' split at closing paren
    vTmp = Split(sData, ")", -1, vbBinaryCompare)
    '
    ' an empty string here indicates this \()
    If vTmp(0) = vbNullString Then
        getInsert = getInsert & "(?)" & Mid(sData, 2)
        Exit Function
    End If
    '
    ' validate found data to integer and >= 0
    ' and check out of bounds condition
    If Not chkFld(CStr(vTmp(0)), "NZI") Then
        getInsert = getInsert & "(?" & vTmp(0) & "?" & Mid(sData, Len(vTmp(0)) + 1)
        Exit Function
    End If
    '
    ' if index is out of bounds leave text unchanged
    If Val(vTmp(0)) <= UBound(vSubs) Then  ' VB checks all conditions so AND won't work
        'If vSubs(Val(vTmp(0))) <> vbNullString Then
            getInsert = getInsert & vSubs(Val(vTmp(0))) & Mid(sData, Len(vTmp(0)) + 2)
            Exit Function         ' <=== not good
        'End If
    End If
    getInsert = getInsert & "?(" & vTmp(0) & ")?" & Mid(sData, Len(vTmp(0)) + 2)
    '
End Function
'
Private Sub Class_Initialize()
'
    sNlsDef = sUsePropPath & "\Properties.txt"
    Set fsDatei = New clsFileString
    Set clsIni = New clsPPStrings
    '
    If Not (fsDatei.existiertDatei(sNlsDef)) Then
        sFehler = "Die Standard Datei:  " & sNlsDef & "  ist nicht vorhanden!"  ' $nonNLS$
    Else
        sFehler = vbNullString
        sUseNlsDsn = sNlsDef
    End If
End Sub

Private Sub Class_Terminate()
'
    Set fsDatei = Nothing
    Set clsIni = Nothing
'
End Sub

