VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsPPStrings"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
' clsPPStrings - Copyright (C)2004 Klaus Dahlenburg, INCOMM GmbH
' Published under the terms and conditions of GNU General Public License Version 2, 1991 or later
'
'=========================
'
'  Changes:
'         1 07/12/2005 Dah
'                    - method getSecData() new optional parameter pTrailer inserted to
'                      remove trailing comments starting with that string. Default = ' \*'
'
'========================

Option Explicit
Private sBuffer As String                       ' return data as C-String !
Private sErgebnis As String                     ' the converted string in VB format
Private lLaenge As Long                         ' length of returned data
Private sFehler As String                       ' error message string
Private coSecData As Collection                 ' holds the formatted section data

Private Declare Function GetPPStrings Lib "kernel32" Alias "GetPrivateProfileStringA" _
                                                       (ByVal lpApplicationName As String, _
                                                        ByVal lpKeyName As Any, _
                                                        ByVal lpDefault As String, _
                                                        ByVal lpReturnedString As String, _
                                                        ByVal nSize As Long, _
                                                        ByVal lpFileName As String) As Long
Private Declare Function GetPrivSection Lib "kernel32" Alias "GetPrivateProfileSectionA" _
                                                        (ByVal lpAppName As String, _
                                                        ByVal lpReturnedString As String, _
                                                        ByVal nSize As Long, _
                                                        ByVal lpFileName As String) As Long
Private Declare Function WritePPString Lib "kernel32" Alias "WritePrivateProfileStringA" _
                                                        (ByVal lpApplicationName As String, _
                                                        ByVal lpKeyName As Any, _
                                                        ByVal lpString As Any, _
                                                        ByVal lpFileName As String) As Long
' -----------------------
' return the error message
' -----------------------
Public Property Get getError() As String
'
    getError = sFehler
'
End Property


' Liest einen Wert aus dessen Abschnitt und der Variable aus
' Rckgabewert Leerstring, falls ein Fehler auftritt !
' Coding: courtesy of  J. Niesner of Metallfabrik Reinhausen GmbH
Public Function getPPString(sDateiName As String, _
                             sVariable As String, _
                             sReturn As String, _
                             Optional sApplication As String = "Options") As Long
    
    sFehler = "*Err*"                           ' Defaultwert, wenn ein Fehler aufgetreten ist
    lLaenge = GetPPStrings(sApplication, sVariable, sFehler, sBuffer, Len(sBuffer), sDateiName)
    
    sErgebnis = Left$(sBuffer, lLaenge)         ' C-String umwandeln
    
    If (sErgebnis = sFehler) Then           ' falls ein Fehler aufgetreten ist
        sReturn = ""                            ' wird ein Leerstring zurckgegeben
        getPPString = -1
    Else
        sFehler = vbNullString
        sReturn = sErgebnis
    End If
End Function
' ------------------------
' get any private section via the windows API
' Sect  the section wanted
' Path the path to the data file
' ------------------------
Public Function GetSection(Path As String, Sect As String, ByRef pReturn As String) As Boolean
'
    GetSection = False
    sFehler = vbNullString
    pReturn = vbNullString
    '
    ' String lesen
    On Error GoTo err_handler:
    lLaenge = GetPrivSection(Sect, sBuffer, Len(sBuffer), Path)
    pReturn = Left$(sBuffer, lLaenge)         ' C-String umwandeln
    GetSection = True
    Exit Function
'
err_handler:
    sFehler = Err.Description
    
End Function
' ------------------------
' Save the section's data in an array
' Sect the section wanted
' Path the path to the data file
' ------------------------
Public Function getSecData(pPath As String, _
                          pSect As String, _
                          Optional pComment As String = vbNullString, _
                          Optional pSkipEmpty As Boolean = True, _
                          Optional pTrailer As String = " \*") As Boolean
Dim sStream As String
Dim vTemp As Variant
Dim i As Long
Dim j As Long
Dim k As Long
Dim sTemp As String
'
    getSecData = False
    sFehler = vbNullString
    '
    On Error GoTo ErrorHandler:
    Set coSecData = New Collection
    '
    If Not GetSection(Path:=pPath, Sect:=pSect, pReturn:=sStream) Then
        Exit Function
    End If
    '
    If Len(sStream) < 1 Then
        getSecData = True
        Exit Function
    End If
    '
    vTemp = Split(sStream, Chr(0), -1, vbBinaryCompare)
    For i = 0 To UBound(vTemp)
        vTemp(i) = Trim(vTemp(i))
        '
        ' should empty lines be removed?
        If pSkipEmpty And _
            vTemp(i) = vbNullString Then
            GoTo continue:
        End If
        '
        ' should comment lines be removed?
        If pComment <> vbNullString Then
            sTemp = Left(vTemp(i), 1)
            For k = 1 To Len(pComment)
                If StrComp(sTemp, Mid(pComment, k, 1), vbBinaryCompare) = 0 Then
                    GoTo continue:
                End If
            Next k
            '
            ' remove any commant strings at end starting with pTrailer
            If pTrailer <> vbNullString Then
                j = InStr(1, vTemp(i), pTrailer, vbTextCompare)
                If j > 0 Then
                    vTemp(i) = Left(vTemp(i), j - 1)
                End If
            End If
            coSecData.Add Trim(vTemp(i))
        End If
continue:
    Next i
    getSecData = True
    '
    Exit Function
    '
ErrorHandler:
    sFehler = "Error in method getSecData(): " & Err.Description
    
End Function
' ------------------------
'
' ------------------------
Public Function getSecDataColl() As Collection
'
    Set getSecDataColl = coSecData
'
End Function
' ------------------------
'
' ------------------------
Public Function WriteINI(pFileName As String, pSec As String, _
                            pProp As String, pValue As String) As Long
'
    On Error GoTo err_handler:
    WriteINI = -1
    WriteINI = WritePPString(pSec, pProp, pValue, pFileName)
    Exit Function
    '
err_handler:
    sFehler = "Error in method WriteIni(): " & Err.Description
'
End Function
'
' pre processing
Private Sub Class_Initialize()
'
    sFehler = vbNullString
    sBuffer = String(4090, Chr$(0))            ' Puffer
    '
End Sub
'
' post processing
Private Sub Class_Terminate()
'
    Set coSecData = Nothing
'
End Sub

